summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authoravnish <avnish.pal@nectechnologies.in>2017-01-12 10:17:37 +0530
committerMonty Taylor <mordred@inaugust.com>2017-01-12 08:17:12 -0500
commit091fde16a38acf17e0d98db44cedc179464aa2f0 (patch)
treec4b2d4d1122c085829a4521ff94c8ec31ff2c81d
parentfcead29c3faa0d7f33e05cd527cbb475542d32ab (diff)
downloados-client-config-091fde16a38acf17e0d98db44cedc179464aa2f0.tar.gz
Use upper-constraints for tox envs
Pin tox environments to upper-constraints to avoid conflicts with library releases. Change-Id: I17664e0794de05fb9661050018dff2a07b077826 Closes-Bug: #1628597
-rwxr-xr-xtools/tox_install.sh30
-rw-r--r--tox.ini6
2 files changed, 35 insertions, 1 deletions
diff --git a/tools/tox_install.sh b/tools/tox_install.sh
new file mode 100755
index 0000000..43468e4
--- /dev/null
+++ b/tools/tox_install.sh
@@ -0,0 +1,30 @@
+#!/usr/bin/env bash
+
+# Client constraint file contains this client version pin that is in conflict
+# with installing the client from source. We should remove the version pin in
+# the constraints file before applying it for from-source installation.
+
+CONSTRAINTS_FILE=$1
+shift 1
+
+set -e
+
+# NOTE(tonyb): Place this in the tox enviroment's log dir so it will get
+# published to logs.openstack.org for easy debugging.
+localfile="$VIRTUAL_ENV/log/upper-constraints.txt"
+
+if [[ $CONSTRAINTS_FILE != http* ]]; then
+ CONSTRAINTS_FILE=file://$CONSTRAINTS_FILE
+fi
+# NOTE(tonyb): need to add curl to bindep.txt if the project supports bindep
+curl $CONSTRAINTS_FILE --insecure --progress-bar --output $localfile
+
+pip install -c$localfile openstack-requirements
+
+# This is the main purpose of the script: Allow local installation of
+# the current repo. It is listed in constraints file and thus any
+# install will be constrained and we need to unconstrain it.
+edit-constraints $localfile -- $CLIENT_NAME
+
+pip install -c$localfile -U $*
+exit $?
diff --git a/tox.ini b/tox.ini
index cedf478..08ba56e 100644
--- a/tox.ini
+++ b/tox.ini
@@ -5,9 +5,13 @@ skipsdist = True
[testenv]
usedevelop = True
-install_command = pip install -U {opts} {packages}
+passenv = ZUUL_CACHE_DIR
+ REQUIREMENTS_PIP_LOCATION
+install_command = {toxinidir}/tools/tox_install.sh {env:UPPER_CONSTRAINTS_FILE:https://git.openstack.org/cgit/openstack/requirements/plain/upper-constraints.txt} {opts} {packages}
setenv =
VIRTUAL_ENV={envdir}
+ BRANCH_NAME=master
+ CLIENT_NAME=os-client-config
deps = -r{toxinidir}/test-requirements.txt
commands = python setup.py testr --slowest --testr-args='{posargs}'